#ifdef GL_ES
	#define LOWP lowp
	precision mediump float;
#else
	#define LOWP
#endif

uniform mat4 u_proj;

attribute vec4 a_position;
attribute vec4 a_color;
attribute float a_illumination;

varying vec4 v_color;
varying float v_illumination;
varying float v_height;

uniform float u_brightness;

#define SineCurveCC(in) sin(clamp(in * (3.14159265359 / 2.0), 0.0, 1.0))
#define BezierTForX(x, c)	(c - sqrt(c*c + x - 2.0*c*x)) / (2.0*c - 1.0)
#define BezierResult(t, c) 2.0 * (1.0 - t) * t * c + t * t

void main()
{
	v_color.rgb = BezierResult(BezierTForX(a_color.rgb, (1.0 - u_brightness)), 1.0);

	v_illumination = a_illumination;
	v_height = a_position.z;
	gl_Position =  u_proj * vec4(a_position.xy, -1.0, 1.0);
}