uniform mat4 u_proj;

attribute vec4 a_position;
attribute vec4 a_color;
attribute float a_illumination;

varying vec4 v_color;
varying float v_illumination;
varying float v_height;

#define SineCurveCC(in)		sin(clamp(in * (3.14159265359 / 2.0), 0.0, 1.0))

void main()
{
	v_color.rgb = SineCurveCC(a_color.rgb);
	v_color.a = a_color.a * (256.0/255.0);
	v_illumination = a_illumination;
	v_height = a_position.z;
	gl_Position =  u_proj * vec4(a_position.xy, -1.0, 1.0);
}