#ifdef GL_ES
	#define LOWP lowp
	precision mediump float;
#else
	#define LOWP 
#endif

varying vec2 v_texCoords;
uniform sampler2D u_texture;

uniform vec2 sourceRes;
uniform float scale;

void main()
{
	vec3 step = vec3(1.0 / scale, 1.0 / scale, 0);
	vec2 tex_pixel = sourceRes * v_texCoords - step.xy / 2.0;
	
	vec2 corner = floor(tex_pixel) + 1.0;
	vec2 frac = min((corner - tex_pixel) * scale, vec2(1.0, 1.0));
	
	vec4 c1 = texture2D(u_texture, (floor(tex_pixel + step.zz) + 0.5) / sourceRes);
	vec4 c2 = texture2D(u_texture, (floor(tex_pixel + step.xz) + 0.5) / sourceRes);
	vec4 c3 = texture2D(u_texture, (floor(tex_pixel + step.zy) + 0.5) / sourceRes);
	vec4 c4 = texture2D(u_texture, (floor(tex_pixel + step.xy) + 0.5) / sourceRes);
	
	c1 *=        frac.x  *        frac.y;
	c2 *= (1.0 - frac.x) *        frac.y;
	c3 *=        frac.x  * (1.0 - frac.y);
	c4 *= (1.0 - frac.x) * (1.0 - frac.y);

	vec4 c = c1 + c2 + c3 + c4;

	gl_FragColor = c;
}