#ifdef GL_ES
	#define LOWP lowp
	#define HIGHP highp
	precision mediump float;
#else
	#define LOWP 
	#define HIGHP
#endif

uniform vec2 resolution;
uniform float time;

varying LOWP vec4 v_color;
varying vec2 v_coord;
varying vec2 v_center;
varying float v_radius;

HIGHP float applyDither4(vec2 pos, float value) {
	HIGHP vec4 dither[4];

	dither[0] = vec4( 1.0, 33.0, 9.0, 41.0);
    dither[1] = vec4(49.0, 17.0, 57.0, 25.0);
    dither[2] = vec4(13.0, 45.0, 5.0, 37.0);
    dither[3] = vec4(61.0, 29.0, 53.0, 21.0);

	HIGHP float limit = dither[int(mod(pos.x, 4.0))][int(mod(pos.y, 4.0))] / 64.0;
	return step(limit, value);
}

void main()
{
	gl_FragColor = vec4(
		v_color.rgb,
		applyDither4(
			gl_FragCoord.xy,
			(1.0 - distance(v_coord, v_center)/v_radius) * 6.0 * v_color.a
		)
	);
}