#ifdef GL_ES
	#define LOWP lowp
	#define HIGHP highp
	precision mediump float;
#else
	#define LOWP 
	#define HIGHP
#endif

uniform vec2 resolution;
uniform float time;

varying LOWP vec4 v_color;
varying vec2 v_coord;
varying vec2 v_center;
varying float v_radius;

const float steps = 2.0;
const float gamma = 3.0;

HIGHP float rand(vec2 co)
{
    HIGHP float a = 12.9898;
    HIGHP float b = 78.233;
    HIGHP float c = 43758.5453;
    HIGHP float dt= dot(co.xy ,vec2(a,b));
    HIGHP float sn= mod(dt,3.14);
    return fract(sin(sn) * c);
}

void main()
{
	float limit = clamp(rand(gl_FragCoord.xy), 0.01, 0.99);

	gl_FragColor = vec4(
		v_color.rgb,
		pow(floor((((1.0 - distance(v_coord, v_center)/v_radius) * 6.0 * v_color.a) / limit) * steps) / steps , 1.0/gamma)
	);
}