#ifdef GL_ES
	#define LOWP lowp
	#define HIGHP highp
	precision mediump float;
#else
	#define LOWP 
	#define HIGHP
#endif

uniform vec2 resolution;
uniform float time;

uniform sampler2D u_texture;
uniform vec2 noiseTextureSize;

varying LOWP vec4 v_color;
varying vec2 v_coord;
varying vec2 v_center;
varying float v_radius;

const float steps = 2.0;
const float gamma = 3.0;

void main()
{
	float limit = texture2D(u_texture, mod( gl_FragCoord.xy / noiseTextureSize, 1.0)).r;

	gl_FragColor = vec4(
		v_color.rgb,
		pow(floor(clamp(((1.0 - distance(v_coord, v_center)/v_radius) * 6.0 * v_color.a) / limit, 0.0, 1.0) * steps) / steps , 1.0/gamma)
	);
}